using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;


namespace _10067
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(56, 40);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(360, 336);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.Name = "Default";
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridGroupingControl1_QueryCellStyleInfo);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(464, 422);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridGroupingControl1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// Display the scroll bars
			this.gridGroupingControl1.TableControl.VScrollBehavior = Syncfusion.Windows.Forms.Grid.GridScrollbarMode.Enabled;
            this.gridGroupingControl1.TableControl.HScrollBehavior = Syncfusion.Windows.Forms.Grid.GridScrollbarMode.Enabled;


            DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();
			DataTable grandChildTable = GetGrandChildTable();

			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable, grandChildTable});

			DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
			DataRelation childToGrandChild = new DataRelation("ChildToGrandChild", childTable.Columns["childID"], grandChildTable.Columns["ChildID"]);

			ds.Relations.AddRange(new DataRelation[]{parentToChild, childToGrandChild });
			
			
			this.gridGroupingControl1.DataSource = parentTable;
			
			this.gridGroupingControl1.NestedTableGroupOptions.ShowCaption = false;

			GridEngine engine = this.gridGroupingControl1.Engine;
			
			//set some parent properties
			GridTableDescriptor parentTableDescriptor = (GridTableDescriptor) engine.TableDescriptor;
			parentTableDescriptor.Columns["parentID"].Appearance.AnyRecordFieldCell.BackColor = Color.LightGoldenrodYellow;
			parentTableDescriptor.Columns["ParentName"].Width = 120;

			//set some child properties
			RelationDescriptor parentToChildRelationDescriptor = parentTableDescriptor.Relations[childTable.TableName];
			GridTableDescriptor childTableDescriptor = (GridTableDescriptor) parentToChildRelationDescriptor.ChildTableDescriptor;
			childTableDescriptor.Columns["Name"].Appearance.AnyRecordFieldCell.BackColor = Color.Pink;
			
			//set some grandchild properties
			RelationDescriptor childToGrandChildRelationDescriptor = childTableDescriptor.Relations[grandChildTable.TableName];
			GridTableDescriptor grandChildTableDescriptor = (GridTableDescriptor) childToGrandChildRelationDescriptor.ChildTableDescriptor;
			grandChildTableDescriptor.Columns["GrandChildID"].Appearance.AnyRecordFieldCell.BackColor = Color.LightBlue;
			grandChildTableDescriptor.Columns["Name"].Appearance.AnyRecordFieldCell.BackColor = Color.LightCoral;    		
		}

		private int numberParentRows = 5;
		private int numberChildRows = 20;
		private int numberGrandChildRows = 50;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");
		
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % (numberParentRows - 2)).ToString();
				dt.Rows.Add(dr);
			}		
			return dt;
		}

		private DataTable GetGrandChildTable()
		{
			DataTable dt = new DataTable("GrandChildTable");

			dt.Columns.Add(new DataColumn("GrandChildID"));
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ChildID")); //upper case C
			
			for(int i = 0; i < numberGrandChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("GrandChildName{0}",i);
				dr[2] = (i % numberChildRows).ToString();
				dt.Rows.Add(dr);
			}
		 return dt;
		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
    		if(e.Style.CellType == "PushButton")
			{
				if(e.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.Record)
				{
					Record rec = (Record) e.TableCellIdentity.DisplayElement.ParentRecord;
					if(rec.NestedTables[0].FilteredRecords.Count == 0)
					{
						e.Style.CellType = "Static";
						e.Style.Enabled = false;
					}
				}			
			}			
		}
	}
}